Compare commits

...

19 Commits

Author SHA1 Message Date
poslop 0664dde3cb rewrite chroot 2026-04-30 10:32:47 -05:00
poslop 91f41fbfba lvm changes 2026-04-30 10:04:00 -05:00
poslop 27b5bf9aa5 fixed awk and sed 2026-04-29 16:16:36 -05:00
poslop 794ca09dfb AHHHHHHHHHHHHHHh I HATE DEBIUAB U AHTE DEBIAN 2026-04-29 15:37:40 -05:00
poslop f06573af1c echo debugs 2026-04-28 13:21:48 -05:00
poslop 8577cd1176 more refactoring 2026-04-28 12:00:42 -05:00
poslop 31c7e91b91 lvm_init 2026-04-28 08:46:33 -05:00
poslop 1e608196a5 partclone in extract script 2026-04-27 16:01:27 -05:00
poslop 4e3f5a158e Remove USB support 2026-04-27 15:26:47 -05:00
poslop 4af9cb4a30 Convert to functions 2026-04-27 15:00:42 -05:00
poslop 4133d22caf part3 and fstab temp 2026-01-26 10:37:48 -06:00
poslop 90e0344210 tset bump 2026-01-16 23:34:31 -06:00
poslop 524d4f0500 Update README.md 2026-01-16 23:30:41 -06:00
poslop 9e980fd07e Update README.md 2026-01-16 23:27:47 -06:00
poslop 5ac621db8a convert to p3 only writing 2026-01-16 23:12:25 -06:00
poslop 2bb5bd8223 extract partitions 2026-01-16 18:29:37 -06:00
poslop a92e5f05de fixed return 2026-01-16 16:19:40 -06:00
poslop 265839faae fixed parameters of get_partition 2026-01-16 16:00:59 -06:00
poslop ce05c833e7 get_partition 2026-01-16 15:55:04 -06:00
7 changed files with 302 additions and 124 deletions
+1
View File
@@ -1,3 +1,4 @@
PBX.img PBX.img
PBX.qcow2 PBX.qcow2
PBX-Test.qcow2 PBX-Test.qcow2
*.snapshot*
+249 -118
View File
@@ -1,137 +1,268 @@
#!/bin/bash #!/bin/bash
set -e set -e
# THE RAINBOW HAHAHAH
RED='\e[31m' RED='\e[31m'
GREEN='\e[32m' GREEN='\e[32m'
YELLOW='\e[33m' YELLOW='\e[33m'
RESET='\e[0m' RESET='\e[0m'
# root check
if [[ $EUID -ne 0 ]]; then
echo -e "${RED}You must be root to do this." 1>&2
exit 100
fi
mount_points=("/dev" "/dev/pts" "/proc" "/sys" "/sys/firmware/efi/efivars" "/run")
NO_WRITE=false NO_WRITE=false
NO_RETABLE=false
NO_USB=false
NO_CLEANUP=false
IMG_FILE="PBX-root.img.lz4"
MOUNT_PATH="/mnt/debian"
MOUNT_POINTS=("/dev" "/dev/pts" "/proc" "/sys" "/sys/firmware/efi/efivars" "/run")
BOOT_PART="NULL"
EFI_PART="NULL"
ROOT_PART="NULL"
VGROUP="SangomaPBX-vg"
ROOT_LV="root"
SWAP_LV="swap_1"
VG_PATH="/dev/mapper/SangomaPBX--vg-"
# arguments
for arg in "$@"; do for arg in "$@"; do
case $arg in case $arg in
--nowrite) --nowrite)
NO_WRITE=true NO_WRITE=true
shift shift
;; ;;
-h) --noretable)
printf "%-20s %s\n" "Flags:" "Description:" NO_RETABLE=true
echo shift
printf "%-20s %s\n" "--nowrite" "Disables Writing to Disk only modifys Existing Partitions" ;;
exit 1 --nocleanup)
;; NO_CLEANUP=true
*) shift
echo "Unknown option: $arg" ;;
echo "Try -h" -h)
exit 1 printf "%-20s %s\n" "Flags:" "Description:"
;; echo
esac printf "%-20s %s\n" "--nowrite" "Disables Writing to Disk only modifys Existing Partitions"
exit 1
;;
*)
echo "Unknown option: $arg"
echo "Try -h"
exit 1
;;
esac
done done
main() {
root_check
udevadm trigger
dialogue
assign_part_var
trap 'echo "Status Code: $?"; cleanup;' EXIT
if [[ $NO_RETABLE == true ]]; then
echo -e "${YELLOW}Option --noretable is specified. Tables will not be erased and no partitions will be created${RESET}"
else
rewrite_gpt_table
assign_part_var
lvm_init
make_filesystem
fi
write_img
mount_chroot
gen_fstab
install_grub
cleanup
echo -e "${GREEN}Restore and resize complete!${RESET}"
}
root_check() {
if [[ $EUID -ne 0 ]]; then
echo -e "${RED}You must be root to do this." 1>&2
exit 100
fi
}
dialogue() {
lsblk
echo
read -rp "Enter the target disk (e.g., sda): " disk_suffix
disk_name="/dev/${disk_suffix}"
echo "Chose disk $disk_name"
echo
}
rewrite_gpt_table() {
sgdisk -Z $disk_name
sgdisk -c $disk_name
sgdisk -n 1:1MiB:+512M -t 1:ef00 -c 1:"EFI System" $disk_name
sgdisk -n 2:0:+1G -t 2:8300 -c 2:"boot" $disk_name
sgdisk -n 3:0:0 -t 3:8e00 -c 3:"Linux LVM" $disk_name
partprobe || true
lsblk $disk_name
echo -e "${GREEN}GPT table created. ${RESET}"
}
assign_part_var() {
EFI_PART=$(get_partition $disk_name "1")
BOOT_PART=$(get_partition $disk_name "2")
ROOT_PART=$(get_partition $disk_name "3")
}
lvm_init() {
pvcreate $ROOT_PART -ff
vgcreate $VGROUP $ROOT_PART -f
vgchange -ay $VGROUP
lvcreate -L 4G $VGROUP -n swap_1
lvcreate -l 100%FREE $VGROUP -n root
echo -e "${GREEN}LVM initialized ${RESET}"
}
make_filesystem() {
mkfs.vfat -F 32 $EFI_PART
mkfs.ext4 $BOOT_PART
mkswap "${VG_PATH}${SWAP_LV}"
echo -e "${GREEN}Make filesystems finished.${RESET}"
}
write_img() {
if [[ $NO_WRITE == true ]]; then
echo -e "${YELLOW}Option --nowrite is specified. No need for Img no disks will be written to${RESET}"
return 0
fi
img_file_dir="null"
if [[ -f "./${IMG_FILE}" ]]; then
img_file_dir="./${IMG_FILE}"
elif [[ -f "./Image/${IMG_FILE}" ]]; then
img_file_dir="./Image/${IMG_FILE}"
elif [[ ! -f $img_file_dir ]]; then
echo -e "${RED}NO IMG FILE FOUND${RESET}"
exit 100
fi
echo "Writing image to ${VG_PATH}${ROOT_LV}..."
lz4 -dc ${img_file_dir} | partclone.ext4 -r -o "${VG_PATH}${ROOT_LV}"
partprobe || true
echo -e "${GREEN}Finished writing image to disk${RESET}"
}
get_partition() {
local disk_name="$1"
local part_num="$2"
local part_path="$(
lsblk -lnp -o NAME,TYPE "$disk_name" |
awk '$2=="part"{print $1}' |
sed -n "${part_num}p"
)"
printf "$part_path"
}
get_partuuid() {
local target_part="$1"
local part_uuid="$(
lsblk -ln -o PATH,PARTUUID $disk_name | awk -v target_part="$target_part" '$1==target_part {print $2}'
)"
printf "$part_uuid"
}
mount_chroot() {
vgchange -ay $VGROUP
echo "Mounting restored system..."
mkdir -p "${MOUNT_PATH}/boot"
mount "${VG_PATH}${ROOT_LV}" $MOUNT_PATH
mount $BOOT_PART "${MOUNT_PATH}/boot"
mkdir -p "${MOUNT_PATH}/boot/efi"
mount $EFI_PART "${MOUNT_PATH}/boot/efi"
for i in "${MOUNT_POINTS[@]}"; do mount -B $i ${MOUNT_PATH}${i}; done
echo -e "${GREEN}Mounts prepared for chroot.${RESET}"
}
gen_fstab() {
echo "Generating fstab..."
boot_uuid=$(get_partuuid $BOOT_PART)
efi_uuid=$(get_partuuid $EFI_PART)
cp ./fstab_template ${MOUNT_PATH}/etc/fstab
sed --in-place "s/BOOT_UUID/${boot_uuid}/g" ${MOUNT_PATH}/etc/fstab
sed --in-place "s/EFI_UUID/${efi_uuid}/g" ${MOUNT_PATH}/etc/fstab
echo -e "${GREEN}fstab write complete!${RESET}"
}
install_grub() {
echo "Entering chroot to reinstall GRUB..."
CHROOT_LINUX_INSTALL="apt install --reinstall -y linux-image-amd64"
CHROOT_INITRAMFS="update-initramfs -c -k all"
CHROOT_GRUB_INSTALL="grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=debian"
CHROOT_GRUB_UPDATE="update-grub"
chroot_cmd "$CHROOT_LINUX_INSTALL"
chroot_cmd "$CHROOT_INITRAMFS"
chroot_cmd "$CHROOT_GRUB_INSTALL"
chroot_cmd "$CHROOT_GRUB_UPDATE"
echo -e "${GREEN}Grub installed!${RESET}"
}
chroot_cmd() {
CHROOT_PATH="export PATH=/usr/sbin:/usr/bin:/sbin:/bin"
chroot $MOUNT_PATH /bin/bash -c "${CHROOT_PATH} && ${1}"
}
cleanup() { cleanup() {
echo "Cleaning Mounts" if [[ $NO_CLEANUP = true ]]; then
echo -e "${YELLOW}No cleanup specified. Make sure to manually clean mounts.${RESET}" 1>&2
umount -lf /mnt/ventoy 2>/dev/null || true exit 100
fi
for i in "${mount_points[@]}"; do umount -lf "/mnt/debian$i" 2>/dev/null || true; done echo "Cleaning Mounts"
umount -lf /mnt/debian/boot/efi 2>/dev/null || true for i in "${MOUNT_POINTS[@]}"; do umount -lf "${MOUNT_PATH}${i}" 2>/dev/null || true; done
umount -lf /mnt/debian/boot 2>/dev/null || true
umount -lf /mnt/debian 2>/dev/null || true umount -lf "${MOUNT_PATH}/boot/efi" 2>/dev/null || true
umount -lf "${MOUNT_PATH}/boot" 2>/dev/null || true
umount -lf "${MOUNT_PATH}" 2>/dev/null || true
vgchange -an $VGROUP
echo -e "${GREEN}Clean.${RESET}"
} }
trap 'echo "Status Code: $?"; cleanup;' EXIT
# Set your target disk here main
udevadm trigger
lsblk
echo
read -rp "Enter the target disk (e.g., sda): " disk_suffix
disk_name="/dev/${disk_suffix}"
echo "Chose disk $disk_name"
echo
if [[ $NO_WRITE == true ]]; then
echo -e "${YELLOW}--nowrite is specified no need for Img no disks will be written to${RESET}"
else
read -rp "Enter the name of the usb partition in /dev/mapper (e.g., sda1): " disk_suffix
usb_name="/dev/mapper/${disk_suffix}"
user_response="n"
read -rp "$(echo -e "${RED}You are about to WRITE and ERASE disk ${disk_name} | Are you sure? y/N: ${RESET}")" user_response
if [[ $user_response != y ]]; then
echo "Exiting script"
exit
fi
echo "Mounting Ventoy..."
mkdir -p /mnt/ventoy
mount $usb_name /mnt/ventoy
cd /mnt/ventoy/Images
echo "Writing image to $disk_name..."
lz4 -dc PBX.img.lz4 | dd of=$disk_name status=progress
fi
# Repartition disk using sgdisk
echo "Repairing partition tables"
sgdisk -e $disk_name
sgdisk -v $disk_name
partprobe || true
echo "Expanding Partition 3 on $disk_name..."
sgdisk --delete=3 $disk_name
sgdisk --new=3:0:0 --typecode=3:8e00 --change-name=3:"Linux LVM" $disk_name
partprobe || true
# Resize physical volume
echo "Resizing physical volume..."
pvresize ${disk_name}3 || true
# Resize swap and root logical volumes
echo "Resizing swap and root volumes..."
lvresize -L +7G PBX-vg/swap_1
lvresize -l +100%FREE --resizefs PBX-vg/root
# Mount restored system for chroot
echo "Mounting restored system..."
mkdir -p /mnt/debian
mount /dev/mapper/PBX--vg-root /mnt/debian/
mount ${disk_name}2 /mnt/debian/boot
mount ${disk_name}1 /mnt/debian/boot/efi
for i in "${mount_points[@]}"; do mount -B $i /mnt/debian$i; done
# Chroot and reinstall GRUB
echo "Entering chroot to reinstall GRUB..."
chroot /mnt/debian /bin/bash -c "
grub-install --target=x86_64-efi --efi-directory=/boot/efi --bootloader-id=debian
update-grub
"
echo -e "${GREEN}Restore and resize complete!${RESET}"
cleanup
BIN
View File
Binary file not shown.
-6
View File
@@ -1,6 +0,0 @@
#!/bin/bash
IMAGE="PBX.img"
fdisk -l ./PBX.img | grep 'PBX\.img[0-9]'
+28
View File
@@ -0,0 +1,28 @@
#!/bin/bash
set -e
RED='\e[31m'
GREEN='\e[32m'
YELLOW='\e[33m'
RESET='\e[0m'
img_file="PBX-Test.img"
if [[ $EUID -ne 0 ]]; then
echo -e "${RED}You must be root to do this." 1>&2
exit 100
fi
losetup -fP $img_file
loop_device=$(losetup -l | grep $img_file | cut -d ' ' -f1)
echo $loop_device
vgchange -a y PBX-vg
lvreduce -L 12G -r PBX-vg/root
partclone.ext4 -c -s /dev/mapper/PBX--vg-root | lz4 -z >./PBX-root.img.lz4
vgchange -a n PBX-vg
losetup -D
+2
View File
@@ -0,0 +1,2 @@
## Used for writing a Debian FreePBX image to a new drive
WIP
+19
View File
@@ -0,0 +1,19 @@
# /etc/fstab: static file system information.
#
# Use 'blkid' to print the universally unique identifier for a
# device; this may be used with UUID= as a more robust way to name devices
# that works even if disks are added and removed. See fstab(5).
#
# systemd generates mount units based on this file, see systemd.mount(5).
# Please run 'systemctl daemon-reload' after making changes here.
# <file system> <mount point> <type> <options> <dump> <pass>
/dev/mapper/SangomaPBX--vg-root / ext4 errors=remount-ro 0 1
# /boot was on /dev/vda2 during installation
UUID=BOOT_UUID /boot ext2 defaults 0 2
# /boot/efi was on /dev/vda1 during installation
UUID=EFI_UUID /boot/efi vfat umask=0077 0 1
/dev/mapper/SangomaPBX--vg-swap_1 none swap sw 0 0